/* $Id: gui_entry.c,v 1.15 2013/04/21 23:02:23 steffen Exp $ */
/***************************************************************************
 *            gui_entry.c
 *  
 *  Copyright (C) 2013  Steffen Pohle
 *  steffen@gulpe.de
 ***************************************************************************
 * basic windows functions
 ***************************************************************************/

/* 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU  General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "osmroute.h"
#include "draw.h"
#include "gui.h"
#include "system.h"

/****************************************************************************
 * entry
 */
void gui_entry_draw (GUIItem *item) {
	char text1[GUI_TEXTLEN];
	char text2[GUI_TEXTLEN];
	struct line_style ls;
	GUIEntry *entry = NULL;

	if (item) entry = (GUIEntry *) item->data;
	else return;

//	d_printf ("gui_entry curpos:%d len:%d", entry->curpos, strlen(entry->text));
//	d_print_data (entry->text, strlen (entry->text)+1);

	ls.width = 1.0;
	if (currentwin->focus == (void*) item)
		ls.c = ls.borderc = color[COLOR_white][3];
	else 
		ls.c = ls.borderc = color[COLOR_white][2];
	gfx_draw_line (currentwin->screen, item->x, item->y+item->h, item->x+item->w, item->y+item->h, ls);
	gfx_draw_line (currentwin->screen, item->x, item->y+item->h, item->x, item->y+item->h-2, ls);
	gfx_draw_line (currentwin->screen, item->x+item->w, item->y+item->h, item->x+item->w, item->y+item->h-2, ls);

	if (entry->curpos >= strlen (entry->text)) {
		entry->curpos = strlen (entry->text);
		snprintf (text1, GUI_TEXTLEN, "%s|", entry->text);
	}
	else if (entry->curpos <= 0) {
		entry->curpos = 0;
		snprintf (text1, GUI_TEXTLEN, "|%s", entry->text);
	}
	else {
		strncpy (text2, entry->text, entry->curpos);
		text2[entry->curpos] = '\0';
		snprintf (text1, GUI_TEXTLEN, "%s|%s", text2, entry->text+entry->curpos);
	}
	gfx_draw_text (currentwin->screen, item->x+2, item->y, text1, &color[COLOR_white][3]);
};


/*
 * event handling 
 */
int gui_entry_event (GUIItem *item, GUIEvent *event) {
	char text[GUI_TEXTLEN];
	char text2[GUI_TEXTLEN];
	GUIEntry *entry = NULL;

	if (item) entry = (GUIEntry *) item->data;

//	d_printf ("gui_entry curpos:%d  keyval:%lx", entry->curpos, event->keyval);

	if (event->event == EGUI_MOUSEPRESSED)	{
		gui_set_focus (item);
		gui_softkeyb_show (TRUE);
	}

	else if (event->event == EGUI_KEYCHAR) {
		if (event->keyval == 0x08) { // backspace
			d_printf ("gui_entry:backspace");
			if (entry->curpos > 0 && entry->curpos < strlen (entry->text)) {
				memset (text, 0x0, GUI_TEXTLEN);
				strncpy (text, entry->text, entry->curpos-1);
				text[entry->curpos] = '\0';
				snprintf (entry->text, GUI_TEXTLEN, "%s%s", text, entry->text+entry->curpos);
				entry->curpos--;
			}
			else if (entry->curpos >= strlen (entry->text)) {
				memset (text, 0x0, GUI_TEXTLEN);
				strncpy (text, entry->text, entry->curpos-1);
				strncpy (entry->text, text, GUI_TEXTLEN);
				entry->curpos--;
			}
			else {
				entry->text[0] = 0;
				entry->curpos = 0;
			}
		}
		else if (event->keyval == 0x1b) {	// esc
			gui_close ();
		}
		else if (event->keyval == 0x0d) {	// enter
			d_printf ("gui_entry:enter");
			if (entry->callback_enter) entry->callback_enter ();
		}
		else if (event->keyval == 0x51) { // left
			d_printf ("gui_entry:curpos--");
			entry->curpos--;
		}
		else if (event->keyval == 0x53) { // right
			d_printf ("gui_entry:curpos++");
			entry->curpos++;
		}
		else if (event->keyval != 0) {
			d_printf ("gui_entry:new text");
			if (entry->curpos == strlen (entry->text)) {
				strncpy (text, entry->text, GUI_TEXTLEN );
				snprintf (entry->text, GUI_TEXTLEN, "%s%c", text, event->keyval);
				entry->curpos++;
			}
			else if (entry->curpos == 0) {
				strncpy (text, entry->text, GUI_TEXTLEN );
				snprintf (entry->text, GUI_TEXTLEN, "%c%s", event->keyval, text);
				entry->curpos++;
			}
			else {
				strncpy (text, entry->text, entry->curpos);
				text[entry->curpos] = '\0';
				snprintf (text2, GUI_TEXTLEN, "%s%c%s", text, event->keyval, entry->text+entry->curpos);
				strncpy (entry->text, text2, GUI_TEXTLEN);
				entry->curpos++;
			}
		}
	}
	currentwin->screen_changed = 1;
	draw ();
	return 1;
};


GUIItem *gui_entry_new (char *text, int x, int y, int w, int h) {
	GUIItem *item = (GUIItem*) ml_malloc (sizeof (GUIItem) + sizeof (GUIEntry) + POINTERALIGNMENT);
	GUIEntry *entry = NULL;

	if (item) entry = (GUIEntry *) item->data;
	
	if (text == NULL) entry->text[0] = 0;
	else strncpy (entry->text, text, GUI_TEXTLEN);
	item->x = x;
	item->y = y;
	item->w = w;
	item->h = h;
	item->type = GUI_ENTRY;
	entry->callback_changed = NULL;
	entry->callback_enter = NULL;

	return item;
};


void gui_entry_settext (GUIItem *item, char *text) {
	GUIEntry *entry = NULL;

	if (item) entry = (GUIEntry *) item->data;
	strncpy (entry->text, text, GUI_TEXTLEN);
	entry->curpos = strlen (entry->text);
	currentwin->screen_changed = 1;
};
